program FORMULE1;
uses crt;

const maxjezdcu=22;
      jmenosouboru='.\formule.dat';  {ulozen textovy soubor}

type Sstring = string[20];
     dat = record d,m,r : integer; end;
     narozen = record miston :Sstring; datn :dat; end;
     firstGP = record mistof :Sstring; datf :dat; end;
     firstwin = record mistow:Sstring; datw :dat; staj:Sstring; end;

     pil = record   jms : Sstring;   {jmeno pilota}
                    jmp : Sstring;   {prijmeni pilota}
                    prp : Sstring;   {jmeno nynejsi staje}
                    nar : narozen;  {narozen}
                    fGP : firstGP;  {1. velka cena}
                    fwin : firstwin;{1. vitezstvi}
                    pGP : integer;  {pocet velkych cen}
                    pPP : integer;  {pocet pole position}
                    pwin : integer; {pocet vitezstvi}
                    ptit : integer; {pocet titulu}
                    pbod : integer; end;  {celkova suma bodu}

     pilo = array [1..maxjezdcu] of pil;

var pilot : pilo;
    i,p,inlist,v : integer;
    f:file of pil;
    jm1,jm2:Sstring;

{----------------------------------------------------------------}
function existuje(name:string):boolean;
var g : text;
begin
 {$I-}
 assign(g,name);
 reset(g);
 close(g);
 {$I+}
 existuje:=(IOResult = 0);
end;


{----------------------------------------------------------------}
procedure initjezdce(var pp:pilo);
var i:integer;
begin
 for i:=1 to maxjezdcu do
 begin
    with pp[i] do
     begin
      jms:=chr(255);  {inicializacni znak}
      jmp:=chr(255);
      prp:=chr(255);
      nar.miston:=chr(255);
      nar.datn.d:=0;
      nar.datn.m:=0;
      nar.datn.r:=0;
      fGP.mistof:=chr(255);
      fGP.datf.d:=0;
      fGP.datf.m:=0;
      fGP.datf.r:=0;
      fwin.mistow:=chr(255);
      fwin.datw.d:=0;
      fwin.datw.m:=0;
      fwin.datw.r:=0;
      fwin.staj:=chr(255);
      pGP:=0;
      pPP:=0;
      Pwin:=0;
      ptit:=0;
      pbod:=0;
     end;
 end;
end;  {proc initstaje}

{----------------------------------------------------------------}
procedure prvniinit(var pp:pilo);
var p : integer;
begin
    with pp[1] do
     begin
      jms:='Ferrari';
      prp:='Schumacher';
      jmp:='Michael';
      nar.miston:='Nemecko/Hurth-Hermulheim';
      nar.datn.d:=3;
      nar.datn.m:=1;
      nar.datn.r:=1969;
      fGP.mistof:='Belgie';
      fGP.datf.d:=0;
      fGP.datf.m:=0;
      fGP.datf.r:=1991;
      fwin.mistow:='Belgie';
      fwin.datw.d:=0;
      fwin.datw.m:=0;
      fwin.datw.r:=1992;
      fwin.staj:='Benneton-Ford';
      pGP:=161;
      pPP:=43;
      Pwin:=53;
      ptit:=5;
      pbod:=801;
     end;

    with pp[2] do
     begin
      jms:='Ferrari';
      prp:='Barrichelo';
      jmp:='Rubens';
      nar.miston:='Brazilie/Sao Paolo';
      nar.datn.d:=23;
      nar.datn.m:=5;
      nar.datn.r:=1972;
      fGP.mistof:='Afrika';
      fGP.datf.d:=0;
      fGP.datf.m:=0;
      fGP.datf.r:=1993;
      fwin.mistow:='USA';
      fwin.datw.d:=0;
      fwin.datw.m:=0;
      fwin.datw.r:=2002;
      fwin.staj:='Ferrari';
      pGP:=145;
      pPP:=5;
      Pwin:=3;
      ptit:=0;
      pbod:=191;
     end;

    with pp[3] do
     begin
      jms:='McLaren-Mercedes';
      prp:='Coulthard';
      jmp:='David';
      nar.miston:='Skotsko/Twinholm';
      nar.datn.d:=27;
      nar.datn.m:=3;
      nar.datn.r:=1971;
      fGP.mistof:='Spanelsko';
      fGP.datf.d:=0;
      fGP.datf.m:=0;
      fGP.datf.r:=1994;
      fwin.mistow:='Portugalsko';
      fwin.datw.d:=0;
      fwin.datw.m:=0;
      fwin.datw.r:=1995;
      fwin.staj:='Williams-Renault';
      pGP:=124;
      pPP:=12;
      Pwin:=12;
      ptit:=0;
      pbod:=359;
     end;

    with pp[4] do
     begin
      jms:='McLaren-Mercedes';
      prp:='Raikkonen';
      jmp:='Kimi';
      nar.miston:='Finsko/Espoo';
      nar.datn.d:=17;
      nar.datn.m:=10;
      nar.datn.r:=1979;
      fGP.mistof:='Australie';
      fGP.datf.d:=0;
      fGP.datf.m:=0;
      fGP.datf.r:=2001;
      fwin.mistow:=chr(255);
      fwin.datw.d:=0;
      fwin.datw.m:=0;
      fwin.datw.r:=0;
      fwin.staj:=chr(255);
      pGP:=17;
      pPP:=0;
      Pwin:=0;
      ptit:=0;
      pbod:=15;
     end;

   with pp[5] do
     begin
      jms:='BMW-WilliamsF1';
      prp:='Schumacher';
      jmp:='Ralf';
      nar.miston:='Nemecko/Hurth-Hermulheim';
      nar.datn.d:=30;
      nar.datn.m:=6;
      nar.datn.r:=1975;
      fGP.mistof:='Australie';
      fGP.datf.d:=0;
      fGP.datf.m:=0;
      fGP.datf.r:=1997;
      fwin.mistow:='Spanelsko';
      fwin.datw.d:=0;
      fwin.datw.m:=0;
      fwin.datw.r:=2001;
      fwin.staj:='BMW-WilliamsF1';
      pGP:=83;
      pPP:=2;
      Pwin:=5;
      ptit:=0;
      pbod:=135;
     end;

    with pp[5] do
     begin
      jms:='BMW-WilliamsF1';
      prp:='Montoya';
      jmp:='Juan Pablo';
      nar.miston:='Bogota';
      nar.datn.d:=20;
      nar.datn.m:=9;
      nar.datn.r:=1975;
      fGP.mistof:='Australie';
      fGP.datf.d:=0;
      fGP.datf.m:=0;
      fGP.datf.r:=2001;
      fwin.mistow:='Rakousko';
      fwin.datw.d:=0;
      fwin.datw.m:=0;
      fwin.datw.r:=2001;
      fwin.staj:='BMW-WilliamsF1';
      pGP:=13;
      pPP:=5;
      Pwin:=3;
      ptit:=0;
      pbod:=85;
     end;
end;

{----------------------------------------------------------------}
procedure pripravpozici(poz:integer);
var j:integer;
begin
 with pilot[poz] do     {init udaju}
   begin
    begin
      jms:=chr(255);  {inicializacni znak}
      jmp:=chr(255);
      prp:=chr(255);
      nar.miston:=chr(255);
      nar.datn.d:=0;
      nar.datn.m:=0;
      nar.datn.r:=0;
      fGP.mistof:=chr(255);
      fGP.datf.d:=0;
      fGP.datf.m:=0;
      fGP.datf.r:=0;
      fwin.mistow:=chr(255);
      fwin.datw.d:=0;
      fwin.datw.m:=0;
      fwin.datw.r:=0;
      fwin.staj:=chr(255);
      pGP:=0;
      pPP:=0;
      Pwin:=0;
      ptit:=0;
      pbod:=0;
     end;
   end;
end;  {procedure pripravpozici}

{----------------------------------------------------------------}
procedure novy(na:integer);

begin
  with pilot[na] do     {zadani udaju}
   begin
    write('jake je jmeno pilota?  :'); readln(jmp);
    write('jake je jeho prijmeni? :'); readln(prp);
    write('Za koho jezdi?         :'); readln(jms);
    write('Kde se narodil?        :'); readln(nar.miston);
    write('Den   :'); readln(nar.datn.d);
    write('Mesic :'); readln(nar.datn.m);
    write('Rok   :'); readln(nar.datn.r);
    write('Kde jel poprve?        :'); readln(fGP.mistof);
    write('Den   :'); readln(fGP.datf.d);
    write('Mesic :'); readln(fGP.datf.m);
    write('Rok   :'); readln(fGP.datf.r);
    write('Kde poprve zvitezil?   :'); readln(fwin.mistow);
    write('Den   :'); readln(fwin.datw.d);
    write('Mesic :'); readln(fwin.datw.m);
    write('Rok   :'); readln(fwin.datw.r);
    write('Za koho jel?           :'); readln(fwin.staj);
    writeln('Nasledujici udaje se tykaji statistik.');
    writeln;
    write('Pocet odjetych velkych cen  :'); readln(pGP);
    write('Pocet pole position         :'); readln(pPP);
    write('Pocet vitezstvi             :'); readln(Pwin);
    write('Pocet ziskanych titulu      :'); readln(ptit);
    write('Celkova suma ziskanych bodu :'); readln(pbod);
    writeln;
    inlist:=inlist+1;
    clrscr;
    writeln;
    writeln('Nyni je v seznamu ',inlist,' jezdcu.');
  end;
 gotoXY(31,24); textcolor(white+blink);write('Stiskni klavesu!!'); readkey;
 normvideo;
end;  {procedure novy}

{----------------------------------------------------------------}
procedure zrus(name1:Sstring;name2:Sstring);
var i,pozice:integer;
begin
 i:=1;
 while (name1<>pilot[i].jmp) and (name2<>pilot[i].prp) and (i<=inlist) do inc(i);
 {na kterem miste je pacient}
 pozice:=i;
 if pozice=inlist+1 then begin writeln('Pilot neni v seznamu!!');
                               textcolor(red+blink);
                               write('Stiskni klavesu!!');
                               readkey;
                         end
                    else for i:=pozice to maxjezdcu do begin
                                                     pripravpozici(i);
                                                     pilot[i]:=pilot[i+1];
                                                    end;
end; {procedure zrus}

{----------------------------------------------------------------}
procedure vypis(p:pilo);
var i,j:integer;
begin
  textcolor(red); write('Databaze Formule1':20);
  writeln;
  textcolor(white);
  writeln;
  writeln('Jmeno':10,
          'Prijmeni':12,
          'Staj':16,
          '#GP':10,
          '#PoP':8,
          '#Win':7,
          '#Tit':7,
          '#Bod':7);
  i:=1;
  writeln;
  while p[i].jmp<>chr(255) do
   begin
    write(i);
    writeln(p[i].jmp:11,
          p[i].prp:11,
          p[i].jms:18,
          p[i].pGP:7,
          p[i].pPP:7,
          p[i].Pwin:7,
          p[i].ptit:7,
          p[i].pbod:7);
     inc(i);
   end;
   gotoXY(34,24); textcolor(red+blink);write('Stiskni klavesu!!');
   readkey;
   normvideo;
end;

{----------------------------------------------------------------}
procedure podrobnosti(var p:pilo; poz:integer);
var i,j:integer;
begin
  clrscr;
  textcolor(red); write('Podrobnosti');
  writeln;
  textcolor(white);
  writeln;
  write('Jmeno                       :'); writeln(p[poz].jmp);
  write('Prijmeni                    :'); writeln(p[poz].prp);
  write('Nyni jezdi za staj          :'); writeln(p[poz].jms);
  writeln;
  write('Pocet velkych cen           :'); writeln(p[poz].pGP);
  write('Pocet pole position         :'); writeln(p[poz].pPP);
  write('Celkovy pocet vitezstvi     :'); writeln(p[poz].pwin);
  write('Pocet ziskanych titulu      :'); writeln(p[poz].ptit);
  write('Celkova suma ziskanych bodu :'); writeln(p[poz].pbod);
  writeln;
  with p[poz] do
  begin
  write('Narodil se dne              :'); writeln(nar.datn.d,'.',nar.datn.m,'.',nar.datn.r);
  write('Misto narozeni              :'); writeln(nar.miston);
  writeln;
  write('Prvni velka cena -den       :'); writeln(fGP.datf.d,'.',fGP.datf.m,'.',fGP.datf.r);
  write('                 -misto     :'); writeln(fGP.mistof);
  writeln;
  write('Prvni vitezstvi  -den       :'); writeln(fwin.datw.d,'.',fwin.datw.m,'.',fwin.datw.r);
  write('                 -misto     :'); writeln(fwin.mistow);
  write('                 -za staj   :'); writeln(fwin.staj);
  end;
  writeln;
  gotoXY(34,24); textcolor(red+blink);write('Stiskni klavesu!!');
  readkey;
  normvideo;
end;

{----------------------------------------------------------------}
procedure QS (var p:pilo; odkud,kam:integer; zzn:char);
var o:integer; {o je pivot}
    i,j:integer; {indexy v poli}
    help:pil;
    oo:sstring;

begin
 if odkud<kam then  {jinak nema smysl}
begin
 case zzn of

 'g' : begin
       o:=p[(odkud+kam) div 2].pgp;  {najdu pivota}
       i:=odkud;
       j:=kam;
       repeat
        while p[i].pgp < o do inc(i);
        while p[j].pgp > o do dec(j);
        if i < j then
         begin {tady musim prehazovat celej zaznam}
          help:=p[i]; p[i]:=p[j]; p[j]:=help;
          inc(i);
          dec(j);
         end
                 else if i = j then
     {indexy I a J se sesly, oba dva ukazuji na hodnotu p}
         begin
          inc(i);    {posun indexu na dalsi prvky}
          dec(j);    {nutne kvuli ukonceni cyklu }
         end
       until i > j;

         if odkud<j then QS(p,odkud,j,zzn);
         if i<kam then QS(p,i,kam,zzn);
       end;

  'p' : begin
       o:=p[(odkud+kam) div 2].ppp;  {najdu pivota}
       i:=odkud;
       j:=kam;
       repeat
        while p[i].ppp < o do inc(i);
        while p[j].ppp > o do dec(j);
        if i < j then
         begin {tady musim prehazovat celej zaznam}
          help:=p[i]; p[i]:=p[j]; p[j]:=help;
          inc(i);
          dec(j);
         end
                 else if i = j then
     {indexy I a J se sesly, oba dva ukazuji na hodnotu p}
         begin
          inc(i);    {posun indexu na dalsi prvky}
          dec(j);    {nutne kvuli ukonceni cyklu }
         end
       until i > j;

         if odkud<j then QS(p,odkud,j,zzn);
         if i<kam then QS(p,i,kam,zzn);
        end;

'v' : begin
       o:=p[(odkud+kam) div 2].pwin;  {najdu pivota}
       i:=odkud;
       j:=kam;
       repeat
        while p[i].pwin < o do inc(i);
        while p[j].pwin > o do dec(j);
        if i < j then
         begin {tady musim prehazovat celej zaznam}
          help:=p[i]; p[i]:=p[j]; p[j]:=help;
          inc(i);
          dec(j);
         end
                 else if i = j then
     {indexy I a J se sesly, oba dva ukazuji na hodnotu p}
         begin
          inc(i);    {posun indexu na dalsi prvky}
          dec(j);    {nutne kvuli ukonceni cyklu }
         end
       until i > j;

         if odkud<j then QS(p,odkud,j,zzn);
         if i<kam then QS(p,i,kam,zzn);
       end;

  't' : begin
       o:=p[(odkud+kam) div 2].ptit;  {najdu pivota}
       i:=odkud;
       j:=kam;
       repeat
        while p[i].ptit < o do inc(i);
        while p[j].ptit > o do dec(j);
        if i < j then
         begin {tady musim prehazovat celej zaznam}
          help:=p[i]; p[i]:=p[j]; p[j]:=help;
          inc(i);
          dec(j);
         end
                 else if i = j then
     {indexy I a J se sesly, oba dva ukazuji na hodnotu p}
         begin
          inc(i);    {posun indexu na dalsi prvky}
          dec(j);    {nutne kvuli ukonceni cyklu }
         end
       until i > j;

         if odkud<j then QS(p,odkud,j,zzn);
         if i<kam then QS(p,i,kam,zzn);
        end;

  'b' : begin
       o:=p[(odkud+kam) div 2].pbod;  {najdu pivota}
       i:=odkud;
       j:=kam;
       repeat
        while p[i].pbod < o do inc(i);
        while p[j].pbod > o do dec(j);
        if i < j then
         begin {tady musim prehazovat celej zaznam}
          help:=p[i]; p[i]:=p[j]; p[j]:=help;
          inc(i);
          dec(j);
         end
                 else if i = j then
     {indexy I a J se sesly, oba dva ukazuji na hodnotu p}
         begin
          inc(i);    {posun indexu na dalsi prvky}
          dec(j);    {nutne kvuli ukonceni cyklu }
         end
       until i > j;

         if odkud<j then QS(p,odkud,j,zzn);
         if i<kam then QS(p,i,kam,zzn);
        end;

  's' : begin
       oo:=p[(odkud+kam) div 2].jms;  {najdu pivota}
       i:=odkud;
       j:=kam;
       repeat
        while p[i].jms  < oo do inc(i);
        while p[j].jms > oo do dec(j);
        if i < j then
         begin {tady musim prehazovat celej zaznam}
          help:=p[i]; p[i]:=p[j]; p[j]:=help;
          inc(i);
          dec(j);
         end
                 else if i = j then
     {indexy I a J se sesly, oba dva ukazuji na hodnotu p}
         begin
          inc(i);    {posun indexu na dalsi prvky}
          dec(j);    {nutne kvuli ukonceni cyklu }
         end
       until i > j;

         if odkud<j then QS(p,odkud,j,zzn);
         if i<kam then QS(p,i,kam,zzn);
        end;


  'j' : begin
       oo:=p[(odkud+kam) div 2].jmp;  {najdu pivota}
       i:=odkud;
       j:=kam;
       repeat
        while p[i].jmp  < oo do inc(i);
        while p[j].jmp > oo do dec(j);
        if i < j then
         begin {tady musim prehazovat celej zaznam}
          help:=p[i]; p[i]:=p[j]; p[j]:=help;
          inc(i);
          dec(j);
         end
                 else if i = j then
     {indexy I a J se sesly, oba dva ukazuji na hodnotu p}
         begin
          inc(i);    {posun indexu na dalsi prvky}
          dec(j);    {nutne kvuli ukonceni cyklu }
         end
       until i > j;

         if odkud<j then QS(p,odkud,j,zzn);
         if i<kam then QS(p,i,kam,zzn);
        end;


  'p' : begin
       oo:=p[(odkud+kam) div 2].prp;  {najdu pivota}
       i:=odkud;
       j:=kam;
       repeat
        while p[i].prp  < oo do inc(i);
        while p[j].prp  > oo do dec(j);
        if i < j then
         begin {tady musim prehazovat celej zaznam}
          help:=p[i]; p[i]:=p[j]; p[j]:=help;
          inc(i);
          dec(j);
         end
                 else if i = j then
     {indexy I a J se sesly, oba dva ukazuji na hodnotu p}
         begin
          inc(i);    {posun indexu na dalsi prvky}
          dec(j);    {nutne kvuli ukonceni cyklu }
         end
       until i > j;

         if odkud<j then QS(p,odkud,j,zzn);
         if i<kam then QS(p,i,kam,zzn);
        end;

  end;
 end;
end;

{----------------------------------------------------------------}
procedure menu;
var zn,znn:char;
    name1,name2:Sstring;
    i,pozice:integer;
begin
 repeat
 clrscr;
 GotoXY(5,5); textcolor(red); write   ('ESC.......konec');
 GotoXY(5,7); textcolor(blue); write  (' N .......novy ');
 GotoXY(5,9); textcolor(blue); write  (' S .......smaz ');
 GotoXY(5,11);textcolor(blue); write  (' V .......vypis');
 GotoXY(5,13);textcolor(blue); write  (' P .......podrobnosti');
 GotoXY(5,15);textcolor(blue); write  (' T .......setrid');

 gotoXY(5,19); textcolor(red+blink);write('Zadej volbu!!');
 normvideo;

 zn:=readkey;
  case zn of
       'v' : begin
              clrscr;
	      vypis(pilot);
             end;

       'p' : begin
              clrscr;
              write('Zadej jmeno pilota:');
              readln(name1);
              i:=1;
              while (name1<>pilot[i].jmp) and (i<=inlist) do inc(i);
              {na kterem miste je pilot}
              pozice:=i;

 if pozice=inlist+1 then begin writeln('Jmeno neni v seznamu!!');
                               textcolor(red+blink);
                               write('Stiskni klavesu!!');
                               readkey;
                         end
                    else
                    begin
                     write('Zadej prijmeni pilota:');
                     readln(name2);
                     i:=1;
                     while (name2<>pilot[i].prp) and (i<=inlist) do inc(i);
                     {na kterem miste je pilot}
                     pozice:=i;

 if pozice=inlist+1 then begin writeln('Prijmeni neni v seznamu!!');
                               textcolor(red+blink);
                               write('Stiskni klavesu!!');
                               readkey;
                         end
                    else
                    begin
                     podrobnosti(pilot,pozice);
                    end;
                   end;
             end;

       'n' : begin
              clrscr;
              writeln ('!! Novy jezdec !!');
              novy(inlist+1);
             end;

       's' : begin
              clrscr;
              writeln('Smazat:');
              write('Jmeno   :'); readln(jm1);
              write('Prijmeni:'); readln(jm2);
              zrus(jm1,jm2);
             end;

       't' : begin
              clrscr;
              writeln ('Podle ceho chces tridit?');
              GotoXY(5,4); textcolor(blue); write  (' J .......jmeno');
              GotoXY(5,6); textcolor(blue); write  (' P .......prijmeni');
              GotoXY(5,8);textcolor(blue); write  (' S .......staj');
              GotoXY(5,10);textcolor(blue); write  (' G .......pocet velkych cen');
              GotoXY(5,12);textcolor(blue); write  (' P .......pocet pole position');
              GotoXY(5,14);textcolor(blue); write  (' V .......pocet vitezstvi');
              GotoXY(5,16);textcolor(blue); write  (' T .......pocet titulu');
              GotoXY(5,18);textcolor(blue); write  (' B .......pocet bodu');
              gotoXY(5,20); textcolor(red+blink);write('Zadej volbu!!');
              normvideo;
              repeat
              znn:=readkey;
              v:=inlist;
              case znn of
               'j' : begin qs(pilot,1,v,'j') end;
               'p' : begin qs(pilot,1,v,'p') end;
               's' : begin qs(pilot,1,v,'s') end;
               'g' : begin qs(pilot,1,v,'g') end;
               'p' : begin qs(pilot,1,v,'p') end;
               'v' : begin qs(pilot,1,v,'v') end;
               't' : begin qs(pilot,1,v,'t') end;
               'b' : begin qs(pilot,1,v,'b') end;  end;
             until (znn in ['j','p','s','g','p','v','t','b']) or (znn=chr(27));
       end;
  end;
 until zn=chr(27);
end;

{----------------------------------------------------------------}
BEGIN
clrscr;
initjezdce(pilot);
for i:=1 to 5 do writeln;
writeln('         *************************************************************');
for i:=1 to 6 do
writeln('         *                                                           *');
writeln('         *************************************************************');
GotoXY(35,8); textcolor(RED); write ('Formule 1');
GotoXY(31,10); textcolor(red); write ('statistiky jezdcu');
gotoXY(31,24); textcolor(white+blink);write('Stiskni klavesu!!'); readkey;
normvideo;
clrscr;
if existuje(jmenosouboru) then begin
                                writeln ('Je to OK, soubor existuje.');
                                gotoXY(31,24);
                                write('Stiskni klavesu!!');
                                readkey;
                                clrscr;
                               end

			  else begin
				writeln ('Soubor "',jmenosouboru,'" nenalezen!!');
                                writeln ('Inicializuji novy soubor.');
				gotoXY(31,24);
				write('Stiskni klavesu!!');
				readkey;
                                assign(f,jmenosouboru);
                                rewrite(f);
                                close(f);
				clrscr;
			       end;

assign(f,jmenosouboru);
p:=0;
reset(f);
inlist:=0;
if not eof(f) then
repeat
 p:=p+1;
 read(f,pilot[p]);
 inlist:=p;
until eof(f)  {konec nacteni staji do pole ve vnitrni pameti}

              else prvniinit(pilot);
close(f);

menu;

rewrite(f);
p:=1;
while (pilot[p].prp<>Chr(255)) and (p<=maxjezdcu) do p:=p+1; {zjisti pocet lidi v listine}
inlist:=p-1;
if inlist<>0 then
begin
 p:=1;
 repeat
  write(f,pilot[p]);
  p:=p+1;
 until p=inlist+1;
end;            {vsichni jezdci v listine jsou zapsani do souboru f}
close(f);

END.
